#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <string>

int main(int argc, char ** argv) 
{
    int opt;
    int opt_port;
    int opt_times = 1;
    std::string opt_svr_address;
    std::string opt_svr_message;

    while (-1 != (opt = getopt(argc, argv, "p:h:m:c:"))) 
    {
        switch (opt) 
        {
            case 'p':
                opt_port = atoi(optarg);
                break;
            case 'h':
                opt_svr_address = optarg;
                break;
            case 'm':
                opt_svr_message = optarg;
                break;
            case 'c':
                opt_times = atoi(optarg);
                break;
            default:
                fprintf(stderr, "Unknown option: %c\n", opt);
                return 1;
        }
    }

    struct sockaddr_in server_addr;
    server_addr.sin_family      = AF_INET;
    server_addr.sin_port        = htons(opt_port);
    server_addr.sin_addr.s_addr = inet_addr(opt_svr_address.c_str());

    int sockfd;
    if ((sockfd = socket(PF_INET, SOCK_STREAM, 0)) < 0) 
    {
        printf("couldn't create socket\n");
        return 1;
    }

    if (connect(sockfd, (struct sockaddr *)&server_addr, sizeof(server_addr)) < 0) 
    {
        printf("couldn't connect\n");
        return 1;
    }

    while (opt_times-- > 0)
    {
        send(sockfd, opt_svr_message.c_str(), opt_svr_message.size(), 0);

        char server_msg[100];
        memset(server_msg, 0, sizeof(server_msg));
        recv(sockfd, server_msg, sizeof(server_msg) , 0);
        printf("%s\n", server_msg);
    }

    close(sockfd);

    return 0;
}
